#include <bits/stdc++.h>

using namespace std;


long int levi[200001],desni[200001];

int a[200001];
int main()
{

    long int n,c,q;
    long int kecevi;
    scanf("%ld%ld%ld",&n,&c,&q);
    getchar();
    for(long int i=0;i<n;i++)
    {
        char s;
        scanf("%c",&s);
        if(s=='1') {a[i]=1; kecevi++;}
    }
    for(long int i=0;i<q;i++)
    {
        scanf("%ld%ld",&levi[i],&desni[i]);
    }
    if(c==n||c>n)
    {
        for(long int i=0;i<q;i++)
        {
            for(long int j=levi[i]-1;j<desni[i];j++)
            {
                if(a[j]) {a[j]=0;kecevi--;}
                else {a[j]=1;kecevi++;}
            }
            printf("%ld\n",kecevi);
        }
    }
    return 0;
}